// audio functions for butt
//
// Copyright 2007 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#ifndef ALSA_H
#define ALSA_H

#include <stdio.h>
#include <stdlib.h>

#include <portaudio.h>

typedef struct
{
    char *name;
    int dev_id;

}snd_dev_t;


extern char* encode_buf;
extern int try_to_connect;
extern bool snd_xrun;
extern bool pa_new_frames;
extern bool reconnect;

int snd_init();
snd_dev_t **snd_get_devices(int *dev_count);
void snd_loop();
void snd_close();

int snd_open_stream();

int snd_callback(const void *input,
                 void *output,
                 unsigned long frameCount,
                 const PaStreamCallbackTimeInfo* timeInfo,
                 PaStreamCallbackFlags statusFlags,
                 void *userData);
int snd_write_buf();
void *snd_rec_thread(void *data);
void *snd_stream_thread(void *data);
void snd_update_vu();

void snd_start_stream();
void snd_stop_stream();
void snd_start_rec();
void snd_stop_rec();

#endif
