#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef _WIN32
 #include <winsock2.h>
 #define close(s) closesocket(s)
#else
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <netdb.h>
#endif

#include "cfg.h"
#include "butt.h"
#include "timer.h"
#include "shoutcast.h"
#include "parseconfig.h"

#include "config.h"


int sc_connect()
{

    int rc;
    char recv_buf[100];
    struct hostent *host_ptr;
    struct sockaddr_in hostname;

#ifdef _WIN32
 WSADATA wsa;
 WSAStartup(MAKEWORD(2,2),&wsa);
#endif

    stream_socket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (stream_socket == -1)
    {

        print_info("\nconnect: could not create network socket", 1);
        return 2;

    }

    host_ptr = gethostbyname(cfg.srv[cfg.selected_srv]->addr);
    if (host_ptr == NULL)
    {
        host_ptr = gethostbyaddr(cfg.srv[cfg.selected_srv]->addr,
                strlen(cfg.srv[cfg.selected_srv]->addr), AF_INET);

        if (host_ptr == NULL)
        {

            print_info("\nconnect: error resolving server address", 1);

            sc_disconnect();
            return 2;

        }
    }

    hostname.sin_family = AF_INET;
    hostname.sin_port = htons(cfg.srv[cfg.selected_srv]->port+1);

    memcpy(&hostname.sin_addr, host_ptr->h_addr,    host_ptr->h_length);

    rc = connect(stream_socket, (struct sockaddr*) &hostname, sizeof(hostname));

    if (rc == -1)
    {
        sc_disconnect();
        return 1;
    }


    send(stream_socket, cfg.srv[cfg.selected_srv]->pwd, strlen(cfg.srv[cfg.selected_srv]->pwd), 0);
    send(stream_socket, "\n", 1, 0);


    rc = recv(stream_socket, recv_buf, sizeof(recv_buf)-1, 0);
    if( (recv_buf[0] != 'O') || (recv_buf[1] != 'K') || (rc <= 2) )
    {

        if(strstr(recv_buf, "invalid") != NULL)
        {
            print_info("\nconnect: invalid password!\n", 1);

            sc_disconnect();
            return 2;
        }
        return 1;
    }

    send(stream_socket, "icy-name:", 9, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->desc != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->desc,
                    strlen(cfg.icy[cfg.selected_icy]->desc), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-genre:", 10, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->genre != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->genre,
                   strlen(cfg.icy[cfg.selected_icy]->genre), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-url:", 8, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->url != NULL)
        send(stream_socket, cfg.icy[cfg.selected_icy]->url,
                strlen(cfg.icy[cfg.selected_icy]->url), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-irc:", 8, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->irc != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->irc,
                    strlen(cfg.icy[cfg.selected_icy]->irc), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-icq:", 8, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->icq != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->icq,
                    strlen(cfg.icy[cfg.selected_icy]->icq), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-aim:", 8, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->aim != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->aim,
                    strlen(cfg.icy[cfg.selected_icy]->aim), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-pub:", 8, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->pub != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->pub,
                    strlen(cfg.icy[cfg.selected_icy]->pub), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "icy-br:", 7, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->br != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->br,
                    strlen(cfg.icy[cfg.selected_icy]->br), 0);

    send(stream_socket, "\n", 1, 0);

    send(stream_socket, "content-type:", 13, 0);
    if(cfg.main.num_of_icy > 0)
        if(cfg.icy[cfg.selected_icy]->type != NULL)
            send(stream_socket, cfg.icy[cfg.selected_icy]->type,
                    strlen(cfg.icy[cfg.selected_icy]->type), 0);

    send(stream_socket, "\n\n", 2, 0);

    connected = 1;
    
    timer_init(&stream_time);       //starts the "online" timer

    sc_update_song();
    return 0;

}

int sc_send(char *buf, int buf_len)
{

    return send(stream_socket, buf, buf_len, 0);
}


void sc_update_song()
{

    int web_socket, rc;
    char send_buf[1024];
    char song_buf[161] = {0};
    char strtok_buf[161];
    char *p;

    struct hostent *webhost_ptr;
    struct sockaddr_in webhost;

    if(cfg.main.song == NULL)
        strcpy(song_buf, "%20");
    else if(strlen(cfg.main.song) == 0)
            strcpy(song_buf, "%20");
    else
    {
        //We need to replace all ascii-spaces (" ") with the http encoded spaces ("%20)
        //otherwise shoutcast will only show the part before the first space....
        strncpy(strtok_buf, cfg.main.song, 160);
        p = strtok(strtok_buf, " ");

        while(p != NULL)
        {
            strcat(song_buf, p);
            p = strtok(NULL, " ");
            if(p != NULL)
               strcat(song_buf, "%20");
        }

        //The same applies to every "&"
        memset(strtok_buf, 0, 161);
        strncpy(strtok_buf, song_buf, 160);
        memset(song_buf, 0, 161);
        p = strtok(strtok_buf, "&");
        while(p != NULL)
        {
            strcat(song_buf, p);
            p = strtok(NULL, "&");
            if(p != NULL)
                strcat(song_buf, "%26");
        }

    }


    web_socket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (web_socket == -1)
    {
        print_info("\nupdate song: could not create web socket", 1);

        close(web_socket);
        return;
    }

    webhost_ptr = gethostbyname(cfg.srv[cfg.selected_srv]->addr);
    if (webhost_ptr == NULL)
    {
        webhost_ptr = gethostbyaddr(cfg.srv[cfg.selected_srv]->addr,
                strlen(cfg.srv[cfg.selected_srv]->addr), AF_INET);

        if (webhost_ptr == NULL)
        {

            print_info("\nupdate song: error resolving server address", 1);

            close(web_socket);
            return;

        }
    }

    webhost.sin_family = AF_INET;
    webhost.sin_port = htons(cfg.srv[cfg.selected_srv]->port);

    memcpy(&webhost.sin_addr, webhost_ptr->h_addr,    webhost_ptr->h_length);

    rc = connect(web_socket, (struct sockaddr*) &webhost, sizeof(webhost));

    if (rc == -1)
    {
        close(web_socket);
        return;
    }

    snprintf(send_buf, 500, "GET /admin.cgi?pass=%s&mode=updinfo&song=%s&url= HTTP/1.0\n"
                      "User-Agent: ShoutcastDSP (Mozilla Compatible)\n\n",
                      cfg.srv[cfg.selected_srv]->pwd,
                      song_buf
                     );

    send(web_socket, send_buf, strlen(send_buf), 0);

    close(web_socket);

    print_info("Current Song updated", 1);


}

void sc_disconnect()
{

    close(stream_socket);
#ifdef _WIN32    
    WSACleanup();
#endif


}
