// timer related functions
//
// Copyright 2007 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include <stdio.h>
#include <stdlib.h>

#include "timer.h"

disp_time rec_time;
disp_time stream_time;

char time_str[10];

void timer_init(disp_time *t)
{

    t->start_time = time(NULL);
    t->new_time   = t->start_time;

}


//This function will be called continuously by the GUI engine
//If it returns 1 the GUI will update the displayed "online time"
int timer_new_time(disp_time *t)
{

    if(time(NULL) != t->new_time || time(NULL) == t->start_time)
        return 1;
    else
        return 0;

}

char *timer_get_time(disp_time *t)
{

    int hour = 0, min = 0, sec = 0;
    time_t cur_time = time(NULL);

    sec = cur_time - t->start_time;

    min = sec / 60;
    hour = min / 60;
    min %= 60;
    sec %= 60;

    snprintf(time_str, 10, "%02d:%02d:%02d", hour, min, sec);

    return time_str;

}



